org.eclipse.viatra.query.patternlanguage.emf.types

## Class EMFPatternTypeProvider

- java.lang.Object
- - org.eclipse.viatra.query.patternlanguage.emf.types.EMFPatternTypeProvider

- All Implemented Interfaces:
    IEMFTypeProvider

  Deprecated.

      @Deprecated
      public class EMFPatternTypeProvider
      extends java.lang.Object
      implements IEMFTypeProvider

  A type provider for inferring the correct types for the pattern variables. It handles all constraints in the model which can modify the outcome of the type, but it has some practical limitations, as the calculation of the proper type can be time consuming in some cases.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `EMFPatternTypeProvider()` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected org.eclipse.xtext.common.types.JvmTypeReference` | `doGetVariableType(Variable variable)` Deprecated.
    `java.util.Map<PathExpressionTail,org.eclipse.emf.ecore.EStructuralFeature>` | `getAllFeaturesFromPathExpressionTail(PathExpressionTail pathExpressionTail)` Deprecated.
    `org.eclipse.emf.ecore.EClassifier` | `getClassifierForLiteralComputationEnumValueReference(ValueReference valueReference)` Deprecated.
    `org.eclipse.emf.ecore.EClassifier` | `getClassifierForType(Type type)` Deprecated.
    `org.eclipse.emf.ecore.EClassifier` | `getClassifierForVariable(Variable variable)` Deprecated.
    `org.eclipse.emf.ecore.EClassifier` | `getExplicitClassifierForPatternParameterVariable(Variable variable)` Deprecated.
    `java.util.Set<org.eclipse.emf.ecore.EClassifier>` | `getIrreducibleClassifiersForVariableInBody(PatternBody patternBody, Variable variable)` Deprecated.
    `org.eclipse.xtext.common.types.JvmTypeReference` | `getJvmType(org.eclipse.emf.ecore.EClassifier classifier, org.eclipse.emf.ecore.EObject context)` Deprecated. Calculates the corresponding JVM type of a selected EClassifier.
    `Type` | `getTypeFromPathExpressionTail(PathExpressionTail pathExpressionTail)` Deprecated.
    `org.eclipse.xtext.common.types.JvmTypeReference` | `getVariableType(Variable variable)` Deprecated. Calculates the JVM type of the selected variable.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EMFPatternTypeProvider

          public EMFPatternTypeProvider()

      Deprecated.

  - ### Method Detail

    - #### getVariableType

          public org.eclipse.xtext.common.types.JvmTypeReference getVariableType(Variable variable)

      Deprecated.
      Description copied from interface: `IEMFTypeProvider`
      Calculates the JVM type of the selected variable. The calculation includes the inference of the corresponding EMF type, and then the calculation of corresponding Java class.
      Specified by:
        `getVariableType` in interface `IEMFTypeProvider`

    - #### doGetVariableType

          protected org.eclipse.xtext.common.types.JvmTypeReference doGetVariableType(Variable variable)

      Deprecated.

    - #### getJvmType

          public org.eclipse.xtext.common.types.JvmTypeReference getJvmType(org.eclipse.emf.ecore.EClassifier classifier,
                                                                            org.eclipse.emf.ecore.EObject context)

      Deprecated.
      Description copied from interface: `IEMFTypeProvider`
      Calculates the corresponding JVM type of a selected EClassifier. The context is used to select the model-specific information, e.g. ResourceSet, project, etc.
      Specified by:
        `getJvmType` in interface `IEMFTypeProvider`

    - #### getClassifierForVariable

          public org.eclipse.emf.ecore.EClassifier getClassifierForVariable(Variable variable)

      Deprecated.
      Specified by:
        `getClassifierForVariable` in interface `IEMFTypeProvider`
      Returns:
        the `EClassifier` for the given `Variable`. Returns null, if it fails.

    - #### getIrreducibleClassifiersForVariableInBody

          public java.util.Set<org.eclipse.emf.ecore.EClassifier> getIrreducibleClassifiersForVariableInBody(PatternBody patternBody,
                                                                                                             Variable variable)

      Deprecated.
      Specified by:
        `getIrreducibleClassifiersForVariableInBody` in interface `IEMFTypeProvider`
      Returns:
        the list of possible classifiers computed from the constraints in the patternbody.

    - #### getExplicitClassifierForPatternParameterVariable

          public org.eclipse.emf.ecore.EClassifier getExplicitClassifierForPatternParameterVariable(Variable variable)

      Deprecated.
      Specified by:
        `getExplicitClassifierForPatternParameterVariable` in interface `IEMFTypeProvider`
      Returns:
        the `EClassifier` explicitly given in the parameter list for the given pattern parameter `Variable`. Returns null, if none found or not a parameter(Ref).

    - #### getClassifierForType

          public org.eclipse.emf.ecore.EClassifier getClassifierForType(Type type)

      Deprecated.
      Specified by:
        `getClassifierForType` in interface `IEMFTypeProvider`
      Returns:
        the `EClassifier` for the given `Type`. Returns null, if it fails.

    - #### getClassifierForLiteralComputationEnumValueReference

          public org.eclipse.emf.ecore.EClassifier getClassifierForLiteralComputationEnumValueReference(ValueReference valueReference)

      Deprecated.
      Specified by:
        `getClassifierForLiteralComputationEnumValueReference` in interface `IEMFTypeProvider`
      Returns:
        an `EClassifier` for the given input `ValueReference`. The ValueReference can be a `LiteralValueReference`, or a `ComputationValue`.

    - #### getTypeFromPathExpressionTail

          public Type getTypeFromPathExpressionTail(PathExpressionTail pathExpressionTail)

      Deprecated.
      Specified by:
        `getTypeFromPathExpressionTail` in interface `IEMFTypeProvider`

    - #### getAllFeaturesFromPathExpressionTail

          public java.util.Map<PathExpressionTail,org.eclipse.emf.ecore.EStructuralFeature> getAllFeaturesFromPathExpressionTail(PathExpressionTail pathExpressionTail)

      Deprecated.
      Specified by:
        `getAllFeaturesFromPathExpressionTail` in interface `IEMFTypeProvider`